// LEDCtrlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LEDCtrl.h"
#include "LEDCtrlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
 HWND hCommWnd;
/////////////////////////////////////////////////////////////////////////////
// CLEDCtrlDlg dialog

//CSerialComDlg::CSerialComDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CSerialComDlg::IDD, pParent)

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLEDCtrlDlg dialog

CLEDCtrlDlg::CLEDCtrlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLEDCtrlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLEDCtrlDlg)
	m_iStopBit = 0;
	m_iSerialPort = 0;
	m_iParity = 0;
	m_iDataBit = 3;
	m_iBaudRate = 1;
	m_strControl = _T("");
	Ch1Mode = TRUE;
	Ch2Mode = TRUE;
	Ch3Mode = TRUE;
	Ch4Mode = TRUE;
	m_strControl = _T("");
	m_iEditch1 = 0;
	m_iEditch2 = 0;
	m_iEditch3 = 0;
	m_iEditch4 = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_iSize=3;
}

void CLEDCtrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLEDCtrlDlg)
	DDX_Control(pDX, IDC_EDITch4, m_Editch4);
	DDX_Control(pDX, IDC_EDITch3, m_Editch3);
	DDX_Control(pDX, IDC_EDITch2, m_Editch2);
	DDX_Control(pDX, IDC_EDITch1, m_Editch1);
	DDX_Control(pDX, IDC_CH4ON, m_ch4on);
	DDX_Control(pDX, IDC_CH4OFF, m_ch4off);
	DDX_Control(pDX, IDC_CH3ON, m_ch3on);
	DDX_Control(pDX, IDC_CH3OFF, m_ch3off);
	DDX_Control(pDX, IDC_CH2ON, m_ch2on);
	DDX_Control(pDX, IDC_CH2OFF, m_ch2off);
	DDX_Control(pDX, IDC_CH1ON, m_ch1on);
	DDX_Control(pDX, IDC_CH1OFF, m_ch1off);
	DDX_Control(pDX, IDC_CONTROL, m_EditControl);
	DDX_Control(pDX, IDC_STOP_BIT, m_cStopBit);
	DDX_Control(pDX, IDC_SERIAL_PORT, m_cSerialPort);
	DDX_Control(pDX, IDC_PARITY, m_cParity);
	DDX_Control(pDX, IDC_DATA_BIT, m_cDataBit);
	DDX_Control(pDX, IDC_BAUD_RATE, m_cBaudRate);
	DDX_CBIndex(pDX, IDC_STOP_BIT, m_iStopBit);
	DDX_CBIndex(pDX, IDC_SERIAL_PORT, m_iSerialPort);
	DDX_CBIndex(pDX, IDC_PARITY, m_iParity);
	DDX_CBIndex(pDX, IDC_DATA_BIT, m_iDataBit);
	DDX_CBIndex(pDX, IDC_BAUD_RATE, m_iBaudRate);
	DDX_Text(pDX, IDC_CONTROL, m_strControl);
	DDX_Control(pDX, IDC_SLIDERCHEL1, m_SliderCtrl1);
	DDX_Control(pDX, IDC_SLIDERCHEL2, m_SliderCtrl2);
	DDX_Control(pDX, IDC_SLIDERCHEL3, m_SliderCtrl3);
	DDX_Control(pDX, IDC_SLIDERCHEL4, m_SliderCtrl4);
	DDX_Text(pDX, IDC_EDITch1, m_iEditch1);
	DDX_Text(pDX, IDC_EDITch2, m_iEditch2);
	DDX_Text(pDX, IDC_EDITch3, m_iEditch3);
	DDX_Text(pDX, IDC_EDITch4, m_iEditch4);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLEDCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(CLEDCtrlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PORT_OPEN, OnPortOpen)
	ON_BN_CLICKED(IDC_PORT_CLOSE, OnPortClose)
	ON_CBN_SELCHANGE(IDC_BAUD_RATE, OnSelchangeBaudRate)
	ON_CBN_SELCHANGE(IDC_DATA_BIT, OnSelchangeDataBit)
	ON_CBN_SELCHANGE(IDC_PARITY, OnSelchangeParity)
	ON_CBN_SELCHANGE(IDC_SERIAL_PORT, OnSelchangeSerialPort)
	ON_CBN_SELCHANGE(IDC_STOP_BIT, OnSelchangeStopBit)
	ON_MESSAGE(WM_COMM_READ , OnCommunication) //߰
	ON_BN_CLICKED(IDC_CH1OFF, OnCh1off)
	ON_BN_CLICKED(IDC_CH1ON, OnCh1on)
	ON_BN_CLICKED(IDC_CH2ON, OnCh2on)
	ON_BN_CLICKED(IDC_CH3ON, OnCh3on)
	ON_BN_CLICKED(IDC_CH4ON, OnCh4on)
	ON_BN_CLICKED(IDC_CH3OFF, OnCh3off)
	ON_BN_CLICKED(IDC_CH4OFF, OnCh4off)
	ON_BN_CLICKED(IDC_CH2OFF, OnCh2off)
	ON_EN_CHANGE(IDC_EDITch1, OnChangeEDITch1)
	ON_EN_CHANGE(IDC_EDITch2, OnChangeEDITch2)
	ON_EN_CHANGE(IDC_EDITch3, OnChangeEDITch3)
	ON_EN_CHANGE(IDC_EDITch4, OnChangeEDITch4)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLEDCtrlDlg message handlers

BOOL CLEDCtrlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
		hCommWnd = m_hWnd;

		if(Ch1Mode==TRUE){
			m_ch1off.EnableWindow(TRUE);m_ch1on.EnableWindow(FALSE); m_Editch1.EnableWindow(TRUE);
		}
		if(Ch2Mode==TRUE){
			m_ch2off.EnableWindow(TRUE);m_ch2on.EnableWindow(FALSE);m_Editch2.EnableWindow(TRUE);
		}
		if(Ch3Mode==TRUE){
			m_ch3off.EnableWindow(TRUE);m_ch3on.EnableWindow(FALSE);m_Editch3.EnableWindow(TRUE);
		}
		if(Ch4Mode==TRUE){
			m_ch4off.EnableWindow(TRUE);m_ch4on.EnableWindow(FALSE);m_Editch4.EnableWindow(TRUE);
		}


	return TRUE;  // return TRUE  unless you set the focus to a control


}

void CLEDCtrlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLEDCtrlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLEDCtrlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLEDCtrlDlg::OnPortOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString PortName;
	PortName.Format("OPEN PORT: %s\r\n",byIndexComPort(m_iSerialPort));
	if(m_ComuPort.m_bConnected == FALSE)//Ʈ   쿡 Ʈ  
	{
		if(m_ComuPort.OpenPort(byIndexComPort(m_iSerialPort), byIndexBaud(m_iBaudRate), byIndexData(m_iDataBit), byIndexStop(m_iStopBit), byIndexParity(m_iParity)) ==TRUE)
		{
			m_EditControl.SetSel(-1,0);
			m_EditControl.ReplaceSel(PortName);
		}
	}
	else
	{
		AfxMessageBox("Already Port open");
	}

}

void CLEDCtrlDlg::OnPortClose() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	CString PortName;
	if(m_ComuPort.m_bConnected == TRUE)
	{	
		m_ComuPort.ClosePort();
		PortName.Format("CLOSE PORT: %s \r\n",byIndexComPort(m_iSerialPort));
		m_EditControl.SetSel(-1,0);
		m_EditControl.ReplaceSel(PortName);
	}
	else
	{
		PortName.Format("%s Port not yet open \r\n",byIndexComPort(m_iSerialPort));
		m_EditControl.SetSel(-1,0);
		m_EditControl.ReplaceSel(PortName);

	}
}
CString CLEDCtrlDlg::byIndexComPort(int xPort)
{
	CString PortName;
	switch(xPort)
	{
		case 0:		PortName = "COM1"; 			break;
			
		case 1:		PortName = "COM2";			break;

		case 2:		PortName = "COM3"; 			break;
		
		case 3:		PortName = "COM4";			break;
			
		case 4:		PortName = "\\\\.\\COM5"; 	break;
			
		case 5:		PortName = "\\\\.\\COM6";	break;
			
		case 6:		PortName = "\\\\.\\COM7"; 	break;
			
		case 7:		PortName = "\\\\.\\COM8";	break;
		
		case 8:		PortName = "\\\\.\\COM9"; 	break;
			
		case 9:		PortName = "\\\\.\\COM10";	break;
	}


	
	return PortName;
}

DWORD CLEDCtrlDlg::byIndexBaud(int xBaud)
{
	DWORD dwBaud;
	switch(xBaud)
	{
		case 0:		dwBaud = CBR_4800;		break;
			
		case 1:		dwBaud = CBR_9600;		break;
	
		case 2:		dwBaud = CBR_14400;		break;
	
		case 3:		dwBaud = CBR_19200;		break;
	
		case 4:		dwBaud = CBR_38400;		break;
	
		case 5:		dwBaud = CBR_56000;		break;
	
		case 6:		dwBaud = CBR_57600;		break;
	
		case 7:		dwBaud = CBR_115200;	break;
	}

	return dwBaud;
}

BYTE CLEDCtrlDlg::byIndexData(int xData)
{
	BYTE byData;
	switch(xData)
	{
		case 0 :	byData = 5;			break;
	
		case 1 :	byData = 6;			break;
		
		case 2 :	byData = 7;			break;
		
		case 3 :	byData = 8;			break;
	}
	return byData;
}

BYTE CLEDCtrlDlg::byIndexStop(int xStop)
{
	BYTE byStop;
	if(xStop == 0)
	{
		byStop = ONESTOPBIT;
	}
	else
	{
		byStop = TWOSTOPBITS;
	}
	return byStop;
}
BYTE CLEDCtrlDlg::byIndexParity(int xParity)
{
	BYTE byParity;
	switch(xParity)
	{
	case 0 :	byParity = NOPARITY;	break;
	
	case 1 :	byParity = ODDPARITY;	break;
	
	case 2 :	byParity = EVENPARITY;	break;
	}

	return byParity;
}

BYTE CLEDCtrlDlg::byCode2AsciiValue(char cData)
{
	// Լ charڸ hex  ִ Լ Դϴ.
	BYTE byAsciiValue;
	if( ( '0' <= cData ) && ( cData <='9' ) )
	{
		byAsciiValue = cData - '0';
	}
	else if( ( 'A' <= cData ) && ( cData <= 'F' ) )
	{
		byAsciiValue = (cData - 'A') + 10;
	}
	else if( ( 'a' <= cData ) && ( cData <= 'f' ) )
	{
		byAsciiValue = (cData - 'a') + 10;
	}
	else
	{
		byAsciiValue = 0;
	}
	return byAsciiValue;
}


void CLEDCtrlDlg::OnSelchangeBaudRate() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	CString change,str;
	m_iBaudRate = m_cBaudRate.GetCurSel();
	if(m_ComuPort.m_bConnected == TRUE)
	{
		m_ComuPort.ClosePort();
		m_ComuPort.OpenPort(byIndexComPort(m_iSerialPort), byIndexBaud(m_iBaudRate), byIndexData(m_iDataBit), byIndexStop(m_iStopBit), byIndexParity(m_iParity));
	}
	m_cBaudRate.GetLBText(m_iBaudRate,str);
	change.Format("BaudRate change: %s \r\n",str);
	m_EditControl.SetSel(-1,0);
	m_EditControl.ReplaceSel(change);
}

void CLEDCtrlDlg::OnSelchangeDataBit() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	CString change,str;
	m_iDataBit = m_cDataBit.GetCurSel();
	if(m_ComuPort.m_bConnected == TRUE)
	{
		m_ComuPort.ClosePort();
		m_ComuPort.OpenPort(byIndexComPort(m_iSerialPort), byIndexBaud(m_iBaudRate), byIndexData(m_iDataBit), byIndexStop(m_iStopBit), byIndexParity(m_iParity));
	}
	m_cDataBit.GetLBText(m_iDataBit,str);
	change.Format("DataBit change: %s \r\n",str);
	m_EditControl.SetSel(-1,0);
	m_EditControl.ReplaceSel(change);
	
}

void CLEDCtrlDlg::OnSelchangeParity() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	CString change,str;
	m_iParity = m_cParity.GetCurSel();
	if(m_ComuPort.m_bConnected == TRUE)
	{
		m_ComuPort.ClosePort();
		m_ComuPort.OpenPort(byIndexComPort(m_iSerialPort), byIndexBaud(m_iBaudRate), byIndexData(m_iDataBit), byIndexStop(m_iStopBit), byIndexParity(m_iParity));
	}
	m_cParity.GetLBText(m_iParity,str);
	change.Format("Parity change: %s \r\n",str);
	m_EditControl.SetSel(-1,0);
	m_EditControl.ReplaceSel(change);
}

void CLEDCtrlDlg::OnSelchangeSerialPort() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString change,str;
	m_iSerialPort = m_cSerialPort.GetCurSel();
	m_cSerialPort.GetLBText(m_iSerialPort,str);
	change.Format("ComPort change: %s \r\n",str);
	m_EditControl.SetSel(-1,0);
	m_EditControl.ReplaceSel(change);
}

void CLEDCtrlDlg::OnSelchangeStopBit() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	CString change, str;
	m_iStopBit= m_cStopBit.GetCurSel();
	if(m_ComuPort.m_bConnected == TRUE)
	{
		m_ComuPort.ClosePort();
		m_ComuPort.OpenPort(byIndexComPort(m_iSerialPort), byIndexBaud(m_iBaudRate), byIndexData(m_iDataBit), byIndexStop(m_iStopBit), byIndexParity(m_iParity));
	}
	m_cStopBit.GetLBText(m_iStopBit,str);
	change.Format("StopBit change: %s \r\n",str);
	m_EditControl.SetSel(-1,0);
	m_EditControl.ReplaceSel(change);
}

BEGIN_EVENTSINK_MAP(CLEDCtrlDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CLEDCtrlDlg)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL1, -606 /* MouseMove */, OnMouseMoveSliderchel1, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL1, -602 /* KeyDown */, OnKeyDownSliderchel1, VTS_PI2 VTS_I2)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL2, -606 /* MouseMove */, OnMouseMoveSliderchel2, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL2, -602 /* KeyDown */, OnKeyDownSliderchel2, VTS_PI2 VTS_I2)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL3, -606 /* MouseMove */, OnMouseMoveSliderchel3, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL3, -602 /* KeyDown */, OnKeyDownSliderchel3, VTS_PI2 VTS_I2)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL4, -606 /* MouseMove */, OnMouseMoveSliderchel4, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CLEDCtrlDlg, IDC_SLIDERCHEL4, -602 /* KeyDown */, OnKeyDownSliderchel4, VTS_PI2 VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CLEDCtrlDlg::OnMouseMoveSliderchel1(short Button, short Shift, long x, long y) 
{
	// TODO: Add your control notification handler code here
	int moveval = m_SliderCtrl1.GetValue();
	CString m_strSend;
	m_strSend="C1";
	if(Button==1){
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
	
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch1= moveval; 
			UpdateData(FALSE);
	}
		
}

void CLEDCtrlDlg::OnKeyDownSliderchel1(short FAR* KeyCode, short Shift) 
{
	// TODO: Add your control notification handler code here
	int moveval = m_SliderCtrl1.GetValue();
	if(*KeyCode==38)	*KeyCode=39;
	if(*KeyCode==40)	*KeyCode=37;	
	CString m_strSend;
	m_strSend="C1";

	if(*KeyCode==37||*KeyCode==39){
		if(*KeyCode==37) moveval--;
		if(*KeyCode==39) moveval++;

		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
			m_iEditch1= moveval; 
					UpdateData(FALSE);
	}

}

void CLEDCtrlDlg::OnMouseMoveSliderchel2(short Button, short Shift, long x, long y) 
{
	// TODO: Add your control notification handler code here
	int moveval = m_SliderCtrl2.GetValue();
	CString m_strSend;
	m_strSend="C2";
	if(Button==1){
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
	
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch2= moveval; 
		UpdateData(FALSE);
	}
			
}

void CLEDCtrlDlg::OnKeyDownSliderchel2(short FAR* KeyCode, short Shift) 
{
	// TODO: Add your control notification handler code here
		int moveval = m_SliderCtrl2.GetValue();
	if(*KeyCode==38)	*KeyCode=39;
	if(*KeyCode==40)	*KeyCode=37;	
	CString m_strSend;
	m_strSend="C2";

	if(*KeyCode==37||*KeyCode==39){
		if(*KeyCode==37) moveval--;
		if(*KeyCode==39) moveval++;

		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch2= moveval; 
		UpdateData(FALSE);
	}
}

void CLEDCtrlDlg::OnMouseMoveSliderchel3(short Button, short Shift, long x, long y) 
{
	// TODO: Add your control notification handler code here
		int moveval = m_SliderCtrl3.GetValue();
	CString m_strSend;
	m_strSend="C3";
	if(Button==1){
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
	
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch3= moveval; 
		UpdateData(FALSE);
	}
		
}

void CLEDCtrlDlg::OnKeyDownSliderchel3(short FAR* KeyCode, short Shift) 
{
	// TODO: Add your control notification handler code here
		int moveval = m_SliderCtrl3.GetValue();
	if(*KeyCode==38)	*KeyCode=39;
	if(*KeyCode==40)	*KeyCode=37;	
	CString m_strSend;
	m_strSend="C3";

	if(*KeyCode==37||*KeyCode==39){
		if(*KeyCode==37) moveval--;
		if(*KeyCode==39) moveval++;

		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch3= moveval; 
		UpdateData(FALSE);
	}
}

void CLEDCtrlDlg::OnMouseMoveSliderchel4(short Button, short Shift, long x, long y) 
{
	// TODO: Add your control notification handler code here
		int moveval = m_SliderCtrl4.GetValue();
	CString m_strSend;
	m_strSend="C4";
	if(Button==1){
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
	
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch4= moveval; 
		UpdateData(FALSE);
	}
		
}

void CLEDCtrlDlg::OnKeyDownSliderchel4(short FAR* KeyCode, short Shift) 
{
	// TODO: Add your control notification handler code here
		int moveval = m_SliderCtrl4.GetValue();
	if(*KeyCode==38)	*KeyCode=39;
	if(*KeyCode==40)	*KeyCode=37;	
	CString m_strSend;
	m_strSend="C4";

	if(*KeyCode==37||*KeyCode==39){
		if(*KeyCode==37) moveval--;
		if(*KeyCode==39) moveval++;

		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		m_iEditch4= moveval; 
		UpdateData(FALSE);
	}
}
long CLEDCtrlDlg::OnCommunication(WPARAM wParam, LPARAM lParam)
{
/*	if(m_iSize >1000){
		m_iSize=0;
		m_EditControl.SetSel(0,-1);
		m_EditControl.Clear();
		m_strControl.Empty();
	}
*/	
	UpdateData(TRUE);//޴  Ÿ ˱ 
	

	CString str = "";
	CString result;
	char size[128];
//	BYTE aByte; //͸   
	int iSize =  (m_ComuPort.m_QueueRead).GetSize(); //Ʈ   
												 //SetCommState     8 
	m_iSize += iSize;	//    â ֱ  
	wsprintf(size,"Receive %d characters\r\n",m_iSize);
	if(iSize != 0)//  0 ƴϸ ȭ鿡   â  
	{
		m_EditControl.SetSel(-1,0);
		m_EditControl.ReplaceSel(size);
	}

/*	for(int i  = 0 ; i < iSize; i++)//  ŭ ͸ о  ȭ鿡 
	{
		(m_ComuPort.m_QueueRead).GetByte(&aByte);//ť  Ѱ о
		switch(m_iReceiveDataType)//޴  Ÿ ASCII or HEX ΰ   ޴  ٸ
		{
		case 0: //Ͱ HEX̸
			str.Format("%02X ", aByte);	
			m_iCount++;//  
			if((m_iCount % 16) == 0) //16   ٲ
			{
				str += _T("\r\n");
			}
			else if((m_iCount % 8) ==0)//8  TAB ־   
			{
				str += _T("\t");
			}
			result += str;
			break;
		case 1://Ͱ ASCII̸
			str.Format("%c", aByte);
			result+= str;
			break;
		}
	}	
	m_EditReceive.SetSel(-1,0);
	m_EditReceive.ReplaceSel(result);//ȭ鿡   
	*/	return 1;

}

void CLEDCtrlDlg::OnCh1off() 
{
	// TODO: Add your control notification handler code here
	m_ch1on.EnableWindow(TRUE);
	m_ch1off.EnableWindow(FALSE);
	m_SliderCtrl1.EnableWindow(FALSE);
	m_Editch1.EnableWindow(FALSE);
		CString m_strSend;
		m_strSend="C1";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		int moveval=0 ;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
}

void CLEDCtrlDlg::OnCh1on() 
{
	// TODO: Add your control notification handler code here
	m_ch1on.EnableWindow(FALSE);
	m_ch1off.EnableWindow(TRUE);
	m_SliderCtrl1.EnableWindow(TRUE);
	m_Editch1.EnableWindow(TRUE);
	int moveval = m_SliderCtrl1.GetValue();
	CString m_strSend;
	m_strSend="C1";

	
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	
}

void CLEDCtrlDlg::OnCh2on() 
{
	// TODO: Add your control notification handler code here
	m_ch2on.EnableWindow(FALSE);
	m_ch2off.EnableWindow(TRUE);
	m_SliderCtrl2.EnableWindow(TRUE);
	m_Editch2.EnableWindow(TRUE);
	int moveval = m_SliderCtrl2.GetValue();
	CString m_strSend;
	m_strSend="C2";

	
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	
}

void CLEDCtrlDlg::OnCh3on() 
{
	// TODO: Add your control notification handler code here
	m_ch3on.EnableWindow(FALSE);
	m_ch3off.EnableWindow(TRUE);
	m_SliderCtrl3.EnableWindow(TRUE);
	m_Editch3.EnableWindow(TRUE);
	int moveval = m_SliderCtrl3.GetValue();
	CString m_strSend;
	m_strSend="C3";

	
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
		
}

void CLEDCtrlDlg::OnCh4on() 
{
	// TODO: Add your control notification handler code here
		m_ch4on.EnableWindow(FALSE);
	m_ch4off.EnableWindow(TRUE);
	m_SliderCtrl4.EnableWindow(TRUE);
	m_Editch4.EnableWindow(TRUE);
	int moveval = m_SliderCtrl4.GetValue();
	CString m_strSend;
	m_strSend="C4";

	
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		if(moveval<0 || moveval>255)return;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	
}


void CLEDCtrlDlg::OnCh3off() 
{
	// TODO: Add your control notification handler code here
		m_ch3on.EnableWindow(TRUE);
	m_ch3off.EnableWindow(FALSE);
	m_SliderCtrl3.EnableWindow(FALSE);
	m_Editch3.EnableWindow(FALSE);
		CString m_strSend;
		m_strSend="C3";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		int moveval=0 ;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
}

void CLEDCtrlDlg::OnCh4off() 
{
	// TODO: Add your control notification handler code here
	m_ch4on.EnableWindow(TRUE);
	m_ch4off.EnableWindow(FALSE);
	m_SliderCtrl4.EnableWindow(FALSE);
	m_Editch4.EnableWindow(FALSE);
		CString m_strSend;
		m_strSend="C4";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		int moveval=0 ;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
}

void CLEDCtrlDlg::OnCh2off() 
{
	// TODO: Add your control notification handler code here
	m_ch2on.EnableWindow(TRUE);
	m_ch2off.EnableWindow(FALSE);
	m_SliderCtrl2.EnableWindow(FALSE);
	m_Editch2.EnableWindow(FALSE);
		CString m_strSend;
		m_strSend="C2";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		int moveval=0 ;
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
}

void CLEDCtrlDlg::OnChangeEDITch1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	if(m_iEditch1==NULL || m_iEditch1<0) return;
	if(m_iEditch1>255) m_iEditch1 = 255;

	int moveval=m_iEditch1 ;
		CString m_strSend;
		m_strSend="C1";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	m_SliderCtrl1.SetValue(moveval);
	UpdateData(FALSE);
	

}

void CLEDCtrlDlg::OnChangeEDITch2() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	
	if(m_iEditch2==NULL || m_iEditch2<0) return;
	if(m_iEditch2>255) m_iEditch2 = 255;

	int moveval=m_iEditch2 ;
		CString m_strSend;
		m_strSend="C2";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	m_SliderCtrl2.SetValue(moveval);
	UpdateData(FALSE);
}

void CLEDCtrlDlg::OnChangeEDITch3() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	
	if(m_iEditch3==NULL || m_iEditch3<0) return;
	if(m_iEditch3>255) m_iEditch3 = 255;

	int moveval=m_iEditch3 ;
		CString m_strSend;
		m_strSend="C3";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	m_SliderCtrl3.SetValue(moveval);
	UpdateData(FALSE);
}

void CLEDCtrlDlg::OnChangeEDITch4() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	if(m_iEditch4==NULL || m_iEditch4<0) return;
	if(m_iEditch4>255) m_iEditch4 = 255;

	int moveval=m_iEditch4 ;
		CString m_strSend;
		m_strSend="C4";
		int nSize = 3;
		int bufPos = 0;
		BYTE *Send_buff;
		Send_buff = new BYTE[nSize];
		CString tre;
		
		for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
		{
			Send_buff[bufPos++] = m_strSend[i];
		}
		Send_buff[bufPos++] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		delete [] Send_buff;
	m_SliderCtrl4.SetValue(moveval);	
	UpdateData(FALSE);
}


void CLEDCtrlDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
		
	CString m_strSend;
	m_strSend="C2";
	int nSize = 5
		;
	int bufPos = 0;
	BYTE *Send_buff;
	Send_buff = new BYTE[nSize];
		
	for(int i = 0; i < 3-1; i++)//ASCII  ̱  Ϳ ״ 
	{
		Send_buff[bufPos++] = m_strSend[i];
	}
	
	int moveval=0;
	i=-1; int j=0;
	while(1){
		moveval=100+moveval*i;
		Send_buff[2] = (unsigned char) moveval;
		m_ComuPort.WriteComm(&Send_buff[0], 3) ;
		j++;
		if(j>100) break;
		Sleep(1);

	}
	
	
	delete [] Send_buff;
	m_iEditch2= moveval; 
	UpdateData(FALSE);
	
}
