// LEDCtrlDlg.h : header file
//
//{{AFX_INCLUDES()
#include "slider.h"
//}}AFX_INCLUDES

#if !defined(AFX_LEDCTRLDLG_H__6B174D4C_5EA5_4AE5_AD29_6AFEAF485E25__INCLUDED_)
#define AFX_LEDCTRLDLG_H__6B174D4C_5EA5_4AE5_AD29_6AFEAF485E25__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "CommThread.h"	// Added by ClassView
/////////////////////////////////////////////////////////////////////////////
// CLEDCtrlDlg dialog

class CLEDCtrlDlg : public CDialog
{
// Construction
public:
	BOOL Ch1Mode;
	BOOL Ch2Mode;
	BOOL Ch3Mode;
	BOOL Ch4Mode;
	CLEDCtrlDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CLEDCtrlDlg)
	enum { IDD = IDD_LEDCTRL_DIALOG };
	CEdit	m_Editch4;
	CEdit	m_Editch3;
	CEdit	m_Editch2;
	CEdit	m_Editch1;
	CButton	m_ch4on;
	CButton	m_ch4off;
	CButton	m_ch3on;
	CButton	m_ch3off;
	CButton	m_ch2on;
	CButton	m_ch2off;
	CButton	m_ch1on;
	CButton	m_ch1off;
	CEdit	m_EditControl;
	CComboBox	m_cStopBit;
	CComboBox	m_cSerialPort;
	CComboBox	m_cParity;
	CComboBox	m_cDataBit;
	CComboBox	m_cBaudRate;
		int		m_iStopBit;
	int		m_iSerialPort;
	int		m_iParity;
	int		m_iDataBit;
	int		m_iBaudRate;
	CString	m_strControl;
	CSlider	m_SliderCtrl1;
	CSlider	m_SliderCtrl2;
	CSlider	m_SliderCtrl3;
	CSlider	m_SliderCtrl4;
	int		m_iEditch1;
	int		m_iEditch2;
	int		m_iEditch3;
	int		m_iEditch4;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLEDCtrlDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	CCommThread m_ComuPort;

private:
	int m_iSize; //â ø    ֱ      
	BYTE byCode2AsciiValue(char cData);// ڸ hex  0~F  ״  ܿ ڴ 0 
	CString byIndexComPort(int xPort);// Ʈ̸ ޱ 
	DWORD byIndexBaud(int xBaud);// ۷ ޱ
	BYTE byIndexData(int xData);// Ʈ ޱ
	BYTE byIndexStop(int xStop);// Ʈ ޱ 
	BYTE byIndexParity(int xParity);// 縮Ƽ ޱ

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CLEDCtrlDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPortOpen();
	afx_msg void OnPortClose();
	afx_msg void OnSelchangeBaudRate();
	afx_msg void OnSelchangeDataBit();
	afx_msg void OnSelchangeParity();
	afx_msg void OnSelchangeSerialPort();
	afx_msg void OnSelchangeStopBit();
	afx_msg void OnMouseMoveSliderchel1(short Button, short Shift, long x, long y);
	afx_msg void OnKeyDownSliderchel1(short FAR* KeyCode, short Shift);
	afx_msg void OnMouseMoveSliderchel2(short Button, short Shift, long x, long y);
	afx_msg void OnKeyDownSliderchel2(short FAR* KeyCode, short Shift);
	afx_msg void OnMouseMoveSliderchel3(short Button, short Shift, long x, long y);
	afx_msg void OnKeyDownSliderchel3(short FAR* KeyCode, short Shift);
	afx_msg void OnMouseMoveSliderchel4(short Button, short Shift, long x, long y);
	afx_msg void OnKeyDownSliderchel4(short FAR* KeyCode, short Shift);
	afx_msg long OnCommunication(WPARAM wParam, LPARAM lParam);// ߰ Ų 
	afx_msg void OnCh1off();
	afx_msg void OnCh1on();
	afx_msg void OnCh2on();
	afx_msg void OnCh3on();
	afx_msg void OnCh4on();
	afx_msg void OnCh3off();
	afx_msg void OnCh4off();
	afx_msg void OnCh2off();
	afx_msg void OnChangeEDITch1();
	afx_msg void OnChangeEDITch2();
	afx_msg void OnChangeEDITch3();
	afx_msg void OnChangeEDITch4();
	afx_msg void OnButton1();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LEDCTRLDLG_H__6B174D4C_5EA5_4AE5_AD29_6AFEAF485E25__INCLUDED_)
